
package de.ivu.elect.presentation.gruppeimgebiet.table;

import static de.ivu.elect.jee.entity.EntityUtil.castTo;

import java.util.Collection;

import de.ivu.elect.business.gebietsbaum.entity.Gebiet;
import de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebiet;
import de.ivu.elect.business.stimmzettel.entity.EntityAufStimmzettelDaten;
import de.ivu.elect.business.wahlvorschlag.entity.Liste;
import de.ivu.elect.business.wahlvorschlag.entity.ListeConstants;
import de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag;
import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.presentation.wahl.CurrentWahlZulassungspruefungExtended;

public class GruppeImGebietListeZulassungColumn extends AbstractGruppeImGebietWahlvorschlagZulassungColumn<Liste> {

  private static final long serialVersionUID = 1L;

  public GruppeImGebietListeZulassungColumn(Messages messages, Gebiet gebiet, EntityAufStimmzettelDaten entityAufStimmzettelDaten, CurrentWahlZulassungspruefungExtended currentWahlZulassungspruefung) {
    super(messages, gebiet, entityAufStimmzettelDaten, currentWahlZulassungspruefung);
  }

  @Override
  public String getHeader() {
    return getMessage(ListeConstants.MESSAGE_KEY_ENTITY_EINZAHL);
  }

  @Override
  protected String getValue(Liste liste) {
    return liste.getKennwort();
  }

  @Override
  protected Liste findWahlvorschlag(GruppeImGebiet gruppeImGebiet, Collection<Wahlvorschlag> wahlvorschlaegeInWahl) {
    for (Wahlvorschlag wahlvorschlag : wahlvorschlaegeInWahl) {
      if (wahlvorschlag.isListe() && isWahlvorschlagRelevantInGebietshierarchie(gruppeImGebiet, wahlvorschlag)) {
        return castTo(wahlvorschlag, Liste.class);
      }
    }

    return null;
  }
}
